#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#ifndef __WATCOMC__
#error Bad command or filename
#endif

#define BS 32000
#define ZERO "zero.dat"

#ifdef VERBOSE
#define SHOW(s) printf(s,l)
#else
#define SHOW(s)
#endif

unsigned char buf[BS];

int main(void) {
  struct _diskfree_t d; long l; FILE* fp; int rc=EXIT_FAILURE;

  if (_dos_getdiskfree(0,&d) == 0xFFFF) goto bye;
  l = (long)d.avail_clusters * (long)d.sectors_per_cluster
      * (long)d.bytes_per_sector;

  memset(buf,0,sizeof(buf)); SHOW("%ld bytes free.\n");

  if ((fp = fopen(ZERO,"wb")) == NULL) goto bye;

  do {
    SHOW("%ld\n");
    fwrite(buf,sizeof(buf),1,fp);
    l -= BS;
  } while (l >= BS);

  SHOW("Final = %ld\n"); fwrite(buf,l,1,fp);

  fclose(fp); remove(ZERO);

  rc = EXIT_SUCCESS;

bye:
  return rc;
}
